function PrinterSafraPay(ScreenService){
	
	var self = this;

	var INVALID_PRINTER_INSTANCE = 'Não foi possível chamar a impressora. Sua instância não existe.';

	this.print = function(){
		if (window.ZhSafraPayPrinter){
			var ret = window.ZhSafraPayPrinter.AbreConexaoImpressora();
			window.returnPrintResult(self.validPrinterResult(ret));
		} else {
			window.returnPrintResult(self.invalidPrinterInstance());
		}
	};

	this.abrePorta = function(){
		self.print();
	};

	this.corteParcial = function(){
		if (window.ZhSafraPayPrinter){
			var ret = window.ZhSafraPayPrinter.Corte(10);
			window.returnPrintResult(self.validPrinterResult(ret));
		} else {
			window.returnPrintResult(self.invalidPrinterInstance());
		}
	};

	this.printText = function(text, parametros){
		if (window.ZhSafraPayPrinter){
			var ret = window.ZhSafraPayPrinter.ImpressaoTexto(text,JSON.stringify(parametros));
			window.returnPrintResult(self.validPrinterResult(ret));
		} else {
			window.returnPrintResult(self.invalidPrinterInstance());
		}
	};

	this.printQRCode = function(qrCode){
		if (window.ZhSafraPayPrinter){
			var ret = window.ZhSafraPayPrinter.ImpressaoQRCode(qrCode,4,4);
			window.returnPrintResult(self.validPrinterResult(ret));
		} else {
			window.returnPrintResult(self.invalidPrinterInstance());
		}
	};

	this.printBarCode = function(barCode){
		if (window.ZhSafraPayPrinter){
			var ret = window.ZhSafraPayPrinter.ImpressaoCodigoBarras(8,"{C"+barCode, 60, 4 ,4);
			window.returnPrintResult(self.validPrinterResult(ret));
		} else {
			window.returnPrintResult(self.invalidPrinterInstance());
		}
	};

	this.imagemBase64=function(imagem){
		if (window.ZhSafraPayPrinter){
			var ret = window.ZhSafraPayPrinter.ImpressaoImagemBase64(imagem);
			window.returnPrintResult(self.validPrinterResult(ret));
		} else {
			window.returnPrintResult(self.invalidPrinterInstance());
		}
	};

	this.imprimirAguardarCallback=function(){
		if (window.ZhSafraPayPrinter){
			//na safrapay só começa a impreimir nessa função e deve esperar o reotrno para executar qualquer outra função
			var ret = window.ZhSafraPayPrinter.ImprimirAguardarCallback();
			//window.returnPrintResult(self.validPrinterResult(ret));
		} else {
			window.returnPrintResult(self.invalidPrinterInstance());
		}
	};

	this.limparBuffer=function(){
		if (window.ZhSafraPayPrinter){
			//na safrapay só começa a impreimir nessa função e deve esperar o reotrno para executar qualquer outra função
			var ret = window.ZhSafraPayPrinter.LimparBuffer();
			//window.returnPrintResult(self.validPrinterResult(ret));
		} else {
			window.returnPrintResult(self.invalidPrinterInstance());
		}
	};

	this.printerDelay = function(time){
		setTimeout(function(){
			var returnObj = self.formatResponse();
			returnObj.error = false;
			window.returnPrintResult(JSON.stringify(returnObj));
		}.bind(this), parseInt(time));	
	};

	this.reprintTEFVoucher = function(){
		window.returnIntegration = _.bind(self.getReprintTextResult, this);
		if (!!window.ZhSafraPayPrinter){
			ZhSafraPayPrinter.showAdministrativeMenu();
		} else {
			window.returnIntegration(self.invalidPrinterInstance());
		}
	};

	this.getReprintTextResult = function(javaResult){
		window.returnPrintResult = _.bind(self.reprintResult, this);
		if(typeof(javaResult) === 'string') {
			javaResult = JSON.parse(javaResult);
		}
		var comandos = [javaResult.customerReceipt, "", ""];
		if(javaResult.paymentTransactionStatus === 0) {
			comandos.forEach(function(text) {
				self.printText(text);
			}.bind(this));
		} else {
			ScreenService.showMessage("Erro ao tentar encontrar o último comprovante TEF");
		}
	};

	this.reprintResult = function (javaResult) {
		if(typeof(javaResult) === 'string') {
			javaResult = JSON.parse(javaResult);
		}

		if(javaResult.paymentTransactionStatus === 1) {
			ScreenService.showMessage("Erro ao imprimir o último comprovante TEF");
		}
	};

	this.printResult = function(resolve, javaResult){
		resolve(javaResult);
	};

	this.invalidPrinterInstance = function(){
		return JSON.stringify({
            'error': true,
            'message': INVALID_PRINTER_INSTANCE
        });
	};
	
	this.validPrinterResult = function(result){
	    if( result < 0 ){
            return { 'error': true, 'message': ("Erro ao executar função de impressão. "+result) };
	    } else {
            return { 'error': false, 'message': false };
	    }
    };

	this.formatResponse = null;

}

Configuration(function(ContextRegister) {
	ContextRegister.register('PrinterSafraPay', PrinterSafraPay);
});