function IntegrationService(IntegrationCappta, IntegrationNTK, IntegrationRede, IntegrationSiTEF, IntegrationCielo, IntegrationGetnet, OperatorRepository, IntegrationPagSeguro, IntegrationADX8000, IntegrationStone, IntegrationSafraPay, IntegrationGPOS720, ScreenService, ApplicationContext, WindowService){
	var INTEGRATION_TYPE = {
		'2': IntegrationCappta,
		'3': IntegrationNTK,
		'4': IntegrationRede,
		'5': IntegrationSiTEF,
		'7': IntegrationCielo,
		'8': IntegrationGetnet,
		'9': IntegrationPagSeguro,
		'A': IntegrationStone,
		'D': IntegrationSiTEF, // IntegrationADX8000 - old
		'E': IntegrationSafraPay,
		'F': IntegrationSiTEF // IntegrationGPOS720 - old
	};

	/*
     * Integrações adicionadas aqui vão cair na handleCancelIntegration e
     * seguir o fluxo do if, que possui a chamada para a função removePayment.
     * Nem todas as integrações precisam disso.
     */
    var INTEGRATION_REMOVE_PAYMENT_FLOW = [
        '5',
        '8',
        '9'
    ];

    var TIMEOUT_TIMER = 60;

    /**
     * Integrações adicionadas aqui vão cair na handlePrintPayment e
     * tentar imprimir a primeira e a segunda via. Nem todas as integrações
     * precisam disso.
     */
    var INTEGRATION_PRINT_STLPRIVIA_STLSEGVIA = [
        '5',
        'D',
		'F'
    ];

	var self = this;
	var IntegrationClass = null;
	var VALUES_NOT_FOUND = 'Tipo do TEF não reconhecido pelo sistema.';

	this.reversalWaiting = Array();
	this.time = 0;

	this.loopTimeOut = function(){
		setTimeout(function(){
			ScreenService.changeLoadingMessage("Aguarde... " + self.time);
			self.time = self.time-1;
			if(self.forcaParadaTimeOut){
				return;
			}
			if(self.time <= 0){
				self.stopTimeOut();
				ScreenService.confirmMessage(
					"ATENÇÃO!<br><br>Não recebemos a resposta do pagamento.<br><br>A cobrança foi realizada no cartão do cliente?",
					"question",
					function () {
						ScreenService.showMessage("Informe o NSU da transação.").then(function(){
							window.ApplicationContext.PaymentController.criaWidget(ApplicationContext.templateManager.container,'popupInformaNSUManual');
							var popup = ApplicationContext.templateManager.container.getWidget("popupInformaNSUManual");
							if(!popup){
								ScreenService.showMessage("Erro ao realizar pagamento.");
							} else {
								popup.getField('nsu').value('');
								popup.currentRow.origem='IntegrationService';
								ScreenService.openPopup(popup);
							}
						});
					},
					function () {
						ScreenService.showMessage("Tente fazer o pagamento novamente.");
						ApplicationContext.PaymentService.getDataUndoPayment().then(function(data){
							ApplicationContext.PaymentService.undoPayment(data.NRSEQMOVMOB,data.paymentData);
						});
					}
				);
			} else {
				self.loopTimeOut();
			}
		},1000);
	};

	this.iniciaTimeOut = function(valorPagamento){
		valorPagamento = valorPagamento||'';
		WindowService.log("iniciaTimeOut TEF "+valorPagamento);
		self.stopTimeOut();
		self.time = TIMEOUT_TIMER;
		self.forcaParadaTimeOut = false;
		ScreenService.hideLoader();
		ScreenService.showLoader();
		self.loopTimeOut();
	};

	this.stopTimeOut = function(){
		self.forcaParadaTimeOut = true;
		ScreenService.changeLoadingMessage("Aguarde...");
		ScreenService.hideLoader();
		ScreenService.hideLoader();
	};

	this.validaNSUManual = function(args){
		WindowService.log("validaNSUManual");
		if(args.owner.getParent().getField('nsu').value()){
			if(args.owner.getParent().currentRow.origem=='IntegrationService'){
				WindowService.log("NSU: "+args.owner.getParent().getField('nsu').value());
				if(self.currentRowTemp && self.resolveTemp){
					self.currentRowTemp.eletronicTransacion.data.CDNSUHOSTTEF = args.owner.getParent().getField('nsu').value();
					self.currentRowTemp.eletronicTransacion.data.VRMOVIVEND = self.currentRowTemp.VRMOVIVEND;
					self.currentRowTemp.eletronicTransacion.data.IDTPTEF = self.currentRowTemp.eletronicTransacion.data.IDTPTEF||operatorData.IDTPTEF;
					ScreenService.closePopup();
					self.stopTimeOut();
					WindowService.log("updatePayment "+self.currentRowTemp.eletronicTransacion.data.CDNSUHOSTTEF);
					self.resolveTemp(JSON.parse(JSON.stringify(self.currentRowTemp.eletronicTransacion)));
				}
			} else if(args.owner.getParent().currentRow.origem=='PaymentController'){
				if(args.owner.getParent().currentRow.pagamentoIncompleto){
					var pagamentoIncompleto = args.owner.getParent().currentRow.pagamentoIncompleto;
					pagamentoIncompleto.CDNSUHOSTTEF = args.owner.getParent().getField('nsu').value();
					pagamentoIncompleto.eletronicTransacion={};
					pagamentoIncompleto.eletronicTransacion.data = JSON.parse(JSON.stringify(pagamentoIncompleto));
					WindowService.log("updatePayment "+pagamentoIncompleto.CDNSUHOSTTEF);
					window.ApplicationContext.PaymentService.updatePayment(pagamentoIncompleto, pagamentoIncompleto.NRSEQMOVMOB).then(function(){
						window.ApplicationContext.PaymentController.backPayment();
					},function(){
						ScreenService.showMessage('Erro ao atualizar o pagamento. Verifique sua conexão com a internet e tente informar o NSU novamente.').then(function(){
							window.ApplicationContext.PaymentController.backPayment();
						});
					});
				} else {
					window.ApplicationContext.PaymentController.backPayment();
				}
			}
		} else {
			ScreenService.showMessage("O NSU informado é inválido.");
		}
	};

	this.onClosePopupInformaNSUManual = function(args){
		if(args.owner.getParent().currentRow.origem=='IntegrationService'){
			ScreenService.closePopup();
			self.iniciaTimeOut('');
			setTimeout(function(){
				self.time = 29;
			},500);
		} else if(args.owner.getParent().currentRow.origem=='PaymentController'){
			window.ApplicationContext.PaymentController.backPayment();
		}
	};

	this.integrationPayment = function(currentRow) {
		return OperatorRepository.findOne().then(function(operatorData) {
			currentRow.eletronicTransacion.data.IDTPTEF = operatorData.IDTPTEF;
			IntegrationClass = self.chooseIntegration(operatorData.IDTPTEF);
			if (IntegrationClass){
				self.iniciaTimeOut((currentRow.VRMOVIVEND||''));
				return new Promise(function(resolve) {
					self.currentRowTemp = currentRow;
					self.resolveTemp = resolve;
					window.returnIntegration = _.bind(IntegrationClass.integrationPaymentResult, IntegrationClass, resolve);
					IntegrationClass.integrationPayment(operatorData, currentRow);
				}).then(self.buildIntegrationResponse.bind(currentRow));
			} else {
				return self.invalidIntegrationValues();
			}
		}.bind(this));
	};

	this.buildIntegrationResponse = function(integrationResult) {
		if(!integrationResult){
			WindowService.log("A resposta devolvida pela integração esta invalida.");
			/*integrationResult={};
			integrationResult.error=true;
			integrationResult.message="A resposta do pagamento esta inválida. Verifique se a cobrança foi efetuada no cartão do cliente.";*/
		}
		self.stopTimeOut();
		WindowService.log("buildIntegrationResponse "+(!integrationResult.error));
		if (!integrationResult.error) {
			for (var i in this.eletronicTransacion.data){
				if (!!integrationResult.data[i]){
					this.eletronicTransacion.data[i] = integrationResult.data[i];
				}
			}
			// Condição específica para Getnet, para adicionar as chaves VRMOVIVEND e IDTIPORECE
			// no objeto eletronicTransacion.data
			if (this.eletronicTransacion.data.IDTPTEF == "8") {
				this.eletronicTransacion.data.VRMOVIVEND = integrationResult.data.VRMOVIVEND;
				this.eletronicTransacion.data.IDTIPORECE = integrationResult.data.IDTIPORECE;
				this.eletronicTransacion.data.NRAUTORIZATEF = integrationResult.data.NRAUTORIZATEF;
			}

			this.eletronicTransacion.status = true;
			integrationResult.data = this;
		}
		return integrationResult;
	};

	this.chooseIntegration = function(IDTPTEF){
		// seleciona serviço de integração
		return INTEGRATION_TYPE[IDTPTEF];
	};

	this.getRemovePaymentFlow = function() {
        return INTEGRATION_REMOVE_PAYMENT_FLOW;
    };

    this.getPrintPriSegVia = function() {
        return INTEGRATION_PRINT_STLPRIVIA_STLSEGVIA;
    };

	this.cancelIntegration = function(tiporeceData){
		return new Promise(function(resolve) {
			if(!tiporeceData.IDTPTEF){
				resolve(self.invalidIntegrationValues("Não é possível fazer o cancelamento porque os dados do pagamento não foram retornados."));
				return;
			}
			IntegrationClass = self.chooseIntegration(tiporeceData.IDTPTEF);
			if (IntegrationClass){
				window.returnIntegration = _.bind(IntegrationClass.cancelIntegrationResult, IntegrationClass, resolve);
				IntegrationClass.cancelIntegration(tiporeceData);
			} else {
				resolve(self.invalidIntegrationValues());
			}
		}.bind(this));	
	};

	this.completeIntegration = function(integrations){
		// pega IDTPTEF da primeira posição pois será o mesmo para qualquer recebimento
		return new Promise(function(resolve) {
			IntegrationClass = self.chooseIntegration(integrations[0].IDTPTEF);
			if (IntegrationClass){			
				window.returnIntegration = _.bind(IntegrationClass.completeIntegrationResult, IntegrationClass, resolve);
				IntegrationClass.completeIntegration();
			} else {
				resolve(self.invalidIntegrationValues());
			}
		}.bind(this));
	};	

	this.callRecursive = null;

	this.reversalIntegration = function(removePaymentSale, integrations){		
		// pega IDTPTEF da primeira posição pois será o mesmo para qualquer recebimento
		return new Promise(function(reversalResolve) {
			IntegrationClass = self.chooseIntegration(integrations[0].IDTPTEF);
			if(IntegrationClass){
				self.reversalWaiting = _.clone(integrations);	
				self.callRecursive = _.bind(this.recursiveReversalIntegration, self, reversalResolve, Array());
				self.callRecursive(removePaymentSale, IntegrationClass);
			} else {
				reversalResolve(self.invalidIntegrationValues());
			}
		}.bind(this));
	};

	this.recursiveReversalIntegration = function(reversalResolve, data, removePaymentSale, IntegrationClass){
		// função recursiva utilizada para estornar todas as transações realizadas na venda
		var integrationToReverse = self.reversalWaiting.shift();
		new Promise(function(resolve){
			// definimos um parametro do objeto global window como uma função que é a reversalIntegrationResult
		    // com ambiente self e argumento resolve
			window.returnIntegration = _.bind(IntegrationClass.reversalIntegrationResult, IntegrationClass, resolve);
            IntegrationClass.reversalIntegration(integrationToReverse);
		}.bind(this)).then(function(resolved){
			WindowService.log("recursiveReversalIntegration resolve");
			if (!resolved.error) {
				resolved.data.REVERSEDNRCONTROLTEF = integrationToReverse.NRCONTROLTEF;
				resolved.data.toRemove = integrationToReverse;	 
				data.push(resolved.data);
				resolved.data = data;

				if (self.reversalWaiting.length > 0){
					// realiza estorno da próxima transação
					self.callRecursive(removePaymentSale, IntegrationClass);
				} else {
					// estorno realizado com sucesso
					reversalResolve(resolved);		
				}					
			} else {
				// erro ao realizar estorno
				data.push(resolved.data);
				resolved.data = data;
				reversalResolve(resolved);
			}
		}.bind(this));
	};

	this.formatResponse = function(){
        return {
            error: true,
            message: '',
            message2: '',
            data: {}
        };
    };

    this.invalidIntegrationValues = function(mensagem){
		mensagem = mensagem||VALUES_NOT_FOUND;
		self.stopTimeOut();
		var result = self.formatResponse();

		result.message = VALUES_NOT_FOUND;
		return result;
	};

	this.backBtnAction = function() {
		return OperatorRepository.findOne().then(function(operatorData) {
			IntegrationClass = self.chooseIntegration(operatorData.IDTPTEF);
			if (IntegrationClass){
				IntegrationClass.abortSitefProcess();
			} else {
				return self.invalidIntegrationValues();
			}
		}.bind(this));
	};

    IntegrationCappta.formatResponse = self.formatResponse;
	IntegrationNTK.formatResponse = self.formatResponse;
	IntegrationRede.formatResponse = self.formatResponse;
	IntegrationSiTEF.formatResponse = self.formatResponse;
	IntegrationGetnet.formatResponse = self.formatResponse;
	IntegrationPagSeguro.formatResponse = self.formatResponse;
	IntegrationADX8000.formatResponse = self.formatResponse;
	IntegrationStone.formatResponse = self.formatResponse;
	IntegrationSafraPay.formatResponse = self.formatResponse;
	IntegrationGPOS720.formatResponse = self.formatResponse;

	this.integrationData = function() {
		return {
			IDTPTEF: operatorData.IDTPTEF,
			CDNSUHOSTTEF: null,
			CDBANCARTCR: null,
			STLPRIVIA: '',
			STLSEGVIA: '',
			PAYMENTCONFIRMATION: false,
			REMOVEALLINTEGRATIONS: false,
			// Cappta
			AUTHKEY: null,
			NRCONTROLTEF: null,
			// SiTEF
			DSENDIPSITEF: '',
			DSENDIPSITEF2: '',
			CDLOJATEF: null,
			CDTERTEF: null,
			TRANSACTIONDATE: '',
			NRCARTBANCO: '',
			//PagSeguro
			TRANSACTIONCODE: '',
			TRANSACTIONID: '',
			NRAUTORIZATEF: null,
			CDTPCOMUNTLS: null,
			CDTOKENTLS: null,
			CDTPPROXYTLS: null,
			CDENPROXYTLS: null
		};
	};

	this.exposeDeviceData = function(data) {
		window.device = {
			platform: data.platform,
			version: data.version,
			uuid: data.uuid,
			model: data.model,
			manufacturer: data.manufacturer,
			buildID: data.buildID,
			logicNumber: data.logicNumber,
			serial: data.serial
		};
	};

}

Configuration(function(ContextRegister) {
	ContextRegister.register('IntegrationService', IntegrationService);
});